
Redmine - Patch #34969

Remove dependency on MimeMagic

2021-03-27 08:30 - Go MAEDA

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Gems support Estimated time: 0.00 hour

Target version: 4.0.9   

Description

In Redmine, MimeMagic is used to check that files with invalid formats are not passed to ImageMagick when generating thumbnail

images with ImageMagick.

This patch replaces MimeMagic with Marcel, a gem bundled with Rails. The benefits of this change are as follows:

Simplifies the installation process: Due to a licensing issue, the MIME database freedesktop.org.xml was removed from

MimeMagic. As a result, you have to make sure that your system has shared-mime-info before you install Redmine. Marcel

bundles another database Apache Tika, so you don't have to install MIME database separately

Can reduce memory usage: By replacing MimeMagic with Marcel, we can reduce one gem dependency. Rails used to depend

on MimeMagic, but in Rails 5.2.5 it no longer does. Now only Redmine itself depends on MimeMagic

Related issues:

Related to Redmine - Patch #34966: Update Rails to 5.2.5 Closed

Associated revisions

Revision 20861 - 2021-03-27 11:16 - Go MAEDA

Remove duplicate code in Redmine::Thumbnail.generate (#34969).

Patch by Go MAEDA.

Revision 20862 - 2021-03-27 11:23 - Go MAEDA

Replace MimeMagic with Marcel (#34969).

Patch by Go MAEDA.

Revision 20877 - 2021-03-31 10:42 - Go MAEDA

Merged r20861 from trunk to 4.1-stable (#34969).

Revision 20878 - 2021-03-31 10:59 - Go MAEDA

Merged r20862 from trunk to 4.1-stable (#34969).

Revision 20953 - 2021-04-20 04:07 - Go MAEDA

Merged r20862 from trunk to 4.0-stable (#34969).

History

#1 - 2021-03-27 08:54 - Go MAEDA

- Related to Patch #34966: Update Rails to 5.2.5 added

#2 - 2021-03-27 09:12 - Go MAEDA

- Target version set to 4.2.0

#3 - 2021-03-27 11:24 - Go MAEDA

- Status changed from New to Closed

- Assignee set to Go MAEDA

Committed the patches.
https://github.com/rails/marcel
https://github.com/mimemagicrb/mimemagic/issues/97
https://tika.apache.org/


#4 - 2021-03-30 01:42 - Go MAEDA

- Status changed from Closed to Reopened

- Target version changed from 4.2.0 to 4.1.3

I think it is better to merge the change to older versions for the following reason. Keep using MimeMagic may cause installation trouble in some

environments.

Go MAEDA wrote:

Simplifies the installation process: Due to a licensing issue, the MIME database freedesktop.org.xml was removed from MimeMagic. As a

result, you have to make sure that your system has shared-mime-info before you install Redmine. Marcel bundles another database 

Apache Tika, so you don't have to install MIME database separately

#5 - 2021-03-31 11:00 - Go MAEDA

- Status changed from Reopened to Closed

Backported to 4.1-stable in r20877 and r20878.

#6 - 2021-04-20 02:06 - Go MAEDA

- Status changed from Closed to Reopened

- Target version changed from 4.1.3 to 4.0.9

#8 - 2021-04-20 04:08 - Go MAEDA

- Status changed from Reopened to Closed

Backported to 4.0-stable in r20953.

Files

0001-Remove-duplicate-code.patch 1.18 KB 2021-03-27 Go MAEDA

0002-Replace-MimeMagic-with-Marcel.patch 1.56 KB 2021-03-27 Go MAEDA
